import csv

from rest_framework.parsers import BaseParser
from rest_framework.exceptions import ParseError


class CSVParser(BaseParser):
    """
    Parses CSV serialized data.

    The parser assumes the first line contains the column names.
    """

    media_type = 'text/csv'

    def parse(self, stream, media_type=None, parser_context=None):
        parser_context = parser_context or {}
        delimiter = parser_context.get('delimiter', ',')

        try:
            rows = csv.reader(stream, delimiter=delimiter)
            header = rows.next()
            data = []
            for row in rows:
                row_data = dict(zip(header, row))
                data.append(row_data)
            return data
        except Exception, exc:
            raise ParseError('CSV parse error - %s' % unicode(exc))
